#parse_ini1.py 8/1/2014  11:03A
# Parse setup.ini file

# Not sure these are necessary
##SAMPLING_RATE = None
##DATA_FILES = None
##RESP_FILES = None
##PLOT_LEGEND = None
##PLOT_POWER = None
##PLOT_SLEEMAN = None
##PLOT_HOLCOMB = None
##PLOT_NLNM = None
##PLOT_MLNM = None
##PLOT_NHNM = None
##TITLE = None
##XMODE = None
##CUTOFF = None
##COLOR_CYCLE = None
##PLOT_LOCALEQ = None
##PLOT_REGIONALEQ = None
##PLOT_TELESEISMICEQ = None
##EQFILES = None

# Comment out the next line if testing parse_ini()
#from setup import * 

def parse_ini():
  
#   Create parameters

    with open("setup.ini", "rU", -1) as setupFile:

######## To test using 'setup import * ', comment out from here...
        line = setupFile.readline()
        while(line != ""):
            if (line[0]!="#" and line[0]!=" " and len(line)>1):
                line=line.strip()
                chunks = line.split ('=')
                if(len(chunks) != 2):
                    print "Malformed setup file"
                    exit(0)
                param = chunks[0]
                value = chunks[1].rstrip()
                if "["in value:

                # Parse a value list
                    while "]" not in value:
                        nextvalue = setupFile.readline()
                        nextvalue = nextvalue.strip()
                        while "]" not in nextvalue:
                            if (nextvalue != "")and (nextvalue[0] != "#"):
                                 value = value + nextvalue
                            nextvalue = setupFile.readline()
                            nextvalue = nextvalue.strip()
                        value = value + nextvalue
                    value=value.translate(None,'[] \'\"').rstrip(',')
                param = param.strip()

            # Asssign a parameter value

                if param == "SAMPLING_RATE":
                    SAMPLING_RATE = float(value)
                elif param == "DATA_FILES":
                    DATA_FILES = value.split(',')
                elif param == "RESP_FILES":
                    RESP_FILES = value.split(',')
                elif param == "PLOT_LEGEND":
                    PLOT_LEGEND = value.strip().lower() == "true"
                elif param == "PLOT_POWER":
                    PLOT_POWER = value.strip().lower() == "true"
                elif param == "PLOT_SLEEMAN":
                    PLOT_SLEEMAN = value.strip().lower() == "true"
                elif param == "PLOT_HOLCOMB":
                    PLOT_HOLCOMB = value.strip().lower() == "true"
                elif param == "PLOT_NLNM":
                    PLOT_NLNM = value.strip().lower() == "true"
                elif param == "PLOT_MLNM":
                    PLOT_MLNM = value.strip().lower() == "true"
                elif param == "PLOT_NHNM":
                    PLOT_NHNM = value.strip().lower() == "true"
                elif param == "PLOT_COHE":
                    PLOT_COHE = value.strip().lower() == "true"
                elif param == "TITLE":
                    TITLE = value.translate(None,'\'\"').lstrip()
                elif param == "XMODE":
                    XMODE = value.translate(None,'\'\"').lstrip()
                elif param == "CUTOFF":
                    CUTOFF =  float(value)
                elif param == "COLOR_CYCLE":
                    COLOR_CYCLE = value.split(',')
                elif param == "PLOT_LOCALEQ":
                    PLOT_LOCALEQ = value.strip().lower() == "true"
                elif param == "PLOT_REGIONALEQ":
                    PLOT_REGIONALEQ = value.strip().lower() == "true"
                elif param == "PLOT_TELESEISMICEQ":
                    PLOT_TELESEISMICEQ = value.strip().lower() == "true"
                elif param == "EQFILES":
                    EQFILES = value.split(',')
                else:
                    print("Unknown parameter name"),param
                    exit(0)
            line = setupFile.readline()
###########    to here

#   Check that values were properly assigned and typed
#   Not sure these tests will be necessary 

        if SAMPLING_RATE is None:
            print "SAMPLING_RATE was not defined."
            exit(0)
        if DATA_FILES is None:
            print "DATA_FILES was not defined."
            exit(0)
        if RESP_FILES is None:
            print "RESP_FILES was not defined."
            exit(0)
        if PLOT_LEGEND is None:
            print "PLOT_LEGEND was not defined."
            exit(0)
        if PLOT_POWER is None:
            print "PLOT_POWER was not defined."
            exit(0)
        if PLOT_SLEEMAN is None:
            print "PLOT_SLEEMAN was not defined."
            exit(0)
        if PLOT_HOLCOMB is None:
            print "PLOT_HOLCOMB was not defined."
            exit(0)
        if PLOT_NLNM is None:
            print "PLOT_NLNM was not defined."
            exit(0)
        if PLOT_MLNM is None:
            print "PLOT_MLNM was not defined."
            exit(0)
        if PLOT_NHNM is None:
            print "PLOT_NHNM was not defined."
            exit(0)
        if PLOT_COHE is None:
            print "PLOT_COHE was not defined."
            exit(0)
        if TITLE is None:
            print "TITLE was not defined."
            exit(0)
        if XMODE is None:
            print "XMODE was not defined."
            exit(0)
        if CUTOFF is None:
            print "CUTOFF was not defined."
            exit(0)
        if COLOR_CYCLE is None:
            print "COLOR_CYCLE was not defined."
            exit(0)
        if PLOT_LOCALEQ is None:
            print "PLOT_LOCALEQ was not defined."
            exit(0)
        if PLOT_REGIONALEQ is None:
            print "PLOT_REGIONALEQ was not defined."
            exit(0)
        if PLOT_TELESEISMICEQ is None:
            print "PLOT_TELESEISMICEQ was not defined."
            exit(0)
        if EQFILES is None:
            print "EQFILES was not defined."
            exit(0)

# Just for testing purposes.  Not to be used in noiseestimate.py
    print
    print "*** Displaying parameter value assignments ***"
    print
    print "SAMPLING_RATE = ",SAMPLING_RATE, type(SAMPLING_RATE)
    print "DATA_FILES = ",DATA_FILES, type(DATA_FILES)
    print "RESP_FILES = ",RESP_FILES, type(RESP_FILES)
    print "PLOT_LEGEND = ",PLOT_LEGEND, type(PLOT_LEGEND)
    print "PLOT_POWER = ",PLOT_POWER, type(PLOT_POWER)
    print "PLOT_SLEEMAN = ",PLOT_SLEEMAN, type(PLOT_SLEEMAN)
    print "PLOT_HOLCOMB = ",PLOT_HOLCOMB, type(PLOT_HOLCOMB)
    print "PLOT_NLNM = ",PLOT_NLNM, type(PLOT_NLNM)
    print "PLOT_MLNM = ",PLOT_MLNM, type(PLOT_MLNM)
    print "PLOT_NHNM = ",PLOT_NHNM, type(PLOT_NHNM)
    print "PLOT_COHE = ",PLOT_COHE, type(PLOT_COHE)
    print "TITLE = ",TITLE, type(TITLE)
    print "XMODE = ",XMODE, type(XMODE)
    print "CUTOFF = ",CUTOFF, type(CUTOFF)
    print "COLOR_CYCLE = ",COLOR_CYCLE, type(COLOR_CYCLE)
    print "PLOT_LOCALEQ = ",PLOT_LOCALEQ, type(PLOT_LOCALEQ)
    print "PLOT_REGIONALEQ = ",PLOT_REGIONALEQ, type(PLOT_REGIONALEQ)
    print "PLOT_TELESEISMICEQ = ",PLOT_TELESEISMICEQ, type(PLOT_TELESEISMICEQ)
    print "EQFILES = ",EQFILES, type(EQFILES)
    return

parse_ini()
